#if !defined(i_file_matrix_h)
#define i_file_matrix_h

#include <stdio.h>
#include <time.h>       // time_t $B7?(B, tm $B7?$NDj5A(B

#include "p_tmp.h"      // $B%/%i%9(B I_file $B$NDj5A(B

// $B%F%s%W%l!<%H%/%i%9(B I_file_matrix $B$NDj5A(B

/*

I_file_matrix<T> $B$O!"Fs<!85%G!<%?$rF~NO%U%!%$%k$+$iFI$_<h$j$^$9!#(B
I_file_matrix<T> $B$O!"(BReceive<T>$B!&(BRelay<T>$B!&(BO_file<T> $BEy$H@\B3$G$-$^$9!#(B

$BF~NO%U%!%$%k$N%U%)!<%^%C%H$O0J2<$N$h$&$G$9!#(B

0 4 3    ------ $B;~9o(B(0), x$BJ}8~$N%;%k?t(B(4), y$BJ}8~$N%;%k?t(B(3)
1 2 3 4  --+
5 6 7 8    |--- 4$B!_(B3$B$N%G!<%?(B
9 1 2 3  --+
3600 4 3 ------ $B;~9o(B(3600), x$BJ}8~$N%;%k?t(B(4), y$BJ}8~$N%;%k?t(B(3)
1 2 3 4  --+
5 6 7 8    |--- 4$B!_(B3$B$N%G!<%?(B
9 1 2 3  --+
7200 4 3 ------ $B;~9o(B(7200), x$BJ}8~$N%;%k?t(B(4), y$BJ}8~$N%;%k?t(B(3)
...      ------ $B0J2<7+$jJV$7(B

1 2 3 4
5 6 7 8
9 1 2 3

$B$H$$$&%G!<%?$,(B KhMatrix<T> a $B$K3JG<$5$l$F$$$k$H$7$?$i!"(B

a.Row ... 4
a.Col ... 3

a(1, 1) a(2, 1) a(3, 1) a(4, 1) 
a(1, 2) a(2, 2) a(3, 2) a(4, 2) 
a(1, 3) a(2, 3) a(3, 3) a(4, 3) 

$B$H$J$j$^$9!#(B

*/

template <class T>
class I_file_matrix : public I_file<T>
{
  public:
    void Input_data(void);

  public:

	//////////////////////////////////////////////////////////////////////
	// Returns a new pointer to a new I_file_matrix&lt T&gt Port
	I_file_matrix<T>* NewPort() { return new I_file_matrix<T>(); }

    Boolean Init(char* f_name) { return I_file<T>::Init(f_name); }

    I_file_matrix(char* f_name) : I_file<T>()
	{
		class_name = "I_file_matrix";
		Init(f_name);
	}

    I_file_matrix(void) : I_file<T>()
    { class_name = "I_file_matrix"; }

    ~I_file_matrix(void) {}

};

#endif  // ! i_file_matrix_h

// end of file
