/* ksedgefc2d.cc */
/* $Lastupdate: Wed Jan 10 15:55:55 2001 $ */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <fstream.h>

#include "ksedgefc2d.h"			// defines class Edge, KsEdgeFc2d
#include "dfopen.h"				// defines function dataFileOpen

//ofstream all_rain_file("all_rain.dat",ios::out); //defined by NAGATANI

Boolean Edge::RegisterUpperEdge // p  upperEdgeArray ɓo^
(
	Edge* p
)
{
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
		if (upperEdgeArray[i] == NULL)
		{
			upperEdgeArray[i] = p;
			return (Boolean)YES;
		}
	}

	return (Boolean)NO;
}

// void Edge::ParametersInFlowModel // ̌vZɕKvȃp^l
// 								 // ǂݍ
// (
// 	double man,					 // }jȎexW (m-s)
//     double m,					 // q = alpha * pow(h, m)  m
// 	double k, 					 // W (m/s)
// 	double d, 					 // Aw (m)
// 	double gamma, 				 // LԌ (-)
// 	double theta, 
// 	double cmin, 				 // minimum C = dQ/dA
// 	double Qlevel, 
// 	double eps, 
// 	int ndiv, 					 // ԍ (-)
// 	int dt						 // time_step (s)
// )
// {
// 	mMan = man;
// 	mM = m;
// 	mK = k;
// 	mD = d;
// 	mGamma = gamma;
// 	mTheta = theta;
// 	mCmin = cmin;
// 	mQlevel = Qlevel;
// 	mEps = eps;
// 	mN = ndiv;
// 	mDt = dt;
// 
// 	mQc = new double[mN+1];
// 	mQn = new double[mN+1];
// 
// 	if (mAtr == 1)
// 	{
// 		mAlpha = sqrt(mGrd) / mMan;
// 		mA = mK * mGrd / mGamma;
// 		mDepth = mD * mGamma;
// 		mDx = mL / (double)mN;
// 	}
// 
// 	mQsmall = mQlevel * mEps * 0.001 / 3600.;
// 	// mQlevel: ʂ̌vZl̊l (mm/hour). 10.0 Wl.
// 	// mEps: vZ̐x (-). 0.001 Wl
// }

void Edge::ParametersInFlowModel // ̌vZɕKvȃp^l
								 // ǂݍ
(
	double man,					 // }jȎexW (m-s)
    double m,					 // q = alpha * pow(h, m)  m
	double k, 					 // W (m/s)
	double d, 					 // Aw (m)
	double gamma, 				 // S󌄗 (-)
    double gammac,				 // ޏe (-)
 	double nf,              	 // SʂƎRʂ̊֌W̃p
								 // ^
	double theta, 
	double cmin, 				 // minimum C = dQ/dA
	double Qlevel, 
	double eps, 
	int ndiv, 					 // ԍ (-)
	int dt						 // time_step (s)
)
{
	mMan = man;
	mM = m;
	mK = k;
	mD = d;
	mGamma = gamma;
	mGammac = gammac;
	mGammae = mGamma - mGammac;
	mNf = nf;
	mTheta = theta;
	mCmin = cmin;
	mQlevel = Qlevel;
	mEps = eps;
	mN = ndiv;
	mDt = dt;

	mQc = new double[mN+1];
	mQn = new double[mN+1];

	if (mAtr == 1)
	{
		mAlpha = sqrt(mGrd) / mMan;
		mA = mK * mGrd / mGammae;
		mDepth = mD * mGammae;
		mHc = mD * mGammac;
		mDx = mL / (double)mN;
	}

	mQsmall = mQlevel * mEps * 0.001 / 3600.;
	// mQlevel: ʂ̌vZl̊l (mm/hour). 10.0 Wl.
	// mEps: vZ̐x (-). 0.001 Wl
}

// void Edge::TopographicData // GbW̌vZɕׂꂽ
// 						   // edge connection V.1 t@C
// 						   // ǂݍ
// (
//  	FILE* fpTopo
// )
// {
// 	// GbWԍǂݍ
// 	fscanf(fpTopo, "%ld", &mNum);
// 	assert(mNum > 0);
// 
// 	// 㗬͓敪̐ǂݍ
// 	assert(fscanf(fpTopo, "%d", &numberOfUpperEdges) == 1);
// 	assert(numberOfUpperEdges >= 0);
// 
// 	// upperEdgeNumArray, upperEdgeArray ̊m
// 	if (numberOfUpperEdges > 0) 
// 	{
// 		upperEdgeNumArray = new long[numberOfUpperEdges];
// 		upperEdgeArray = new Edge*[numberOfUpperEdges];
// 	}
// 	else						// numberOfUpperEdges == 0
// 	{
// 		upperEdgeNumArray = new long;
// 		upperEdgeArray = new Edge*;
// 	}
// 
// 	// upperEdgeArray ̏
// 	for (int i = 0; i < numberOfUpperEdges; i++)
// 		upperEdgeArray[i] = NULL;
// 
// 	// 㗬͓敪̔ԍǂݍ
// 	for (int i = 0; i < numberOfUpperEdges; i++)
// 	{
// 		long num;
// 		assert(fscanf(fpTopo, "%ld", &num) == 1);
// 		upperEdgeNumArray[i] = num;
// 	}
// 
// 	// ͓敪̐ǂݍ
// 	int tmp;
// 	assert(fscanf(fpTopo, "%d", &tmp) == 1);
// 	assert(tmp >= 0);
// 
// 	// ͓敪̔ԍǂݍ
// 
// 	Boolean outEdgeFromLowerEnd = (Boolean)NO;
// 	// [痬oGbWꍇ YES
// 
// 	for (int i = 0; i < tmp; i++)
// 	{
// 		long num;
// 		assert(fscanf(fpTopo, "%ld", &num) == 1);
// 		if (num < 0) outEdgeFromLowerEnd = (Boolean)YES;
// 	}
// 
// 	// GbW̑ǂݍ
// 
// 	assert(fscanf(fpTopo, "%d", &tmp) == 1);
// 	assert(tmp == 1 || tmp == 2);
// 	mAtr = tmp;
// 
// 	// ŉ[̃GbWǂmF
// 	if (mAtr == 2 && outEdgeFromLowerEnd == (Boolean)NO) // ŉ[GbW
// 		lowestEdge = (Boolean)YES;
// 	else 
// 		lowestEdge = (Boolean)NO;
// 
// 	// mAtr  1 ̂Ƃ(_-_GbŴƂ)
// 	// GbW̒AzAʐςǂݍ
// 
// 	if (mAtr == 1)
// 	{
// 		double wlen, wgrd, warea;
// 		assert(fscanf(fpTopo, "%lf %lf %lf", &wlen, &wgrd, &warea)
// 			   == 3);
// 		assert(wlen > 0.0);
// 		assert(wgrd > 0.0);
// 		assert(warea > 0.0);
// 
// 		mArea = warea;
// 		mWidth = mArea / wlen;
// 
// // 		printf("wlen : %f\n", wlen);
// // 		printf("wgrd : %f\n", wgrd);
// 
// 		// wlen ͐Ȃ̂3ɕϊ
// 		mL = wlen * sqrt(1.0 + wgrd*wgrd);
// 
// // 		printf("mL : %f\n", mL);
// 
// 		// wgrd  tangent ̒lȂ̂ŁAsin ̒lɕϊ
// 		wgrd = atan(wgrd);
// 		mGrd = sin(wgrd);
// 
// 		// mCos ߂BmCos ͍~xɏ悶
// 		mCos = cos(asin(mGrd));
// 	}
// 
// // 	// for debugging
// //  	printf("%ld : %d %f %f %f %f %f %d %d\n",
// //  		mNum, mAtr, mL, mArea, mWidth, mGrd, mCos,
// //  		   numberOfUpperEdges, lowestEdge);
// }

void Edge::TopographicData // GbW̌vZɕׂꂽ
						   // edge connection V.2/3/4/5 t@C
						   // ǂݍ
(
 	FILE* fpTopo,
    int wTopoDataType
)
{
	// GbWԍǂݍ()
	fscanf(fpTopo, "%ld", &mNum);
	assert(mNum > 0);

	// GbW_̍Wǂݍ(V.2/3)A
	// GbW㉺[̃m[hԍƂꂼ̍Wlǂݍ݁A
	// GbW_̍WvZ(V.4/5)B
	if (wTopoDataType == 2 || wTopoDataType == 3)
	{
		fscanf(fpTopo, "%lf %lf %lf", &mX, &mY, &mZ);
	}
	else if (wTopoDataType == 4 || wTopoDataType == 5)
	{
		long wNum;
		double wUpX, wUpY, wUpZ, wLowX, wLowY, wLowZ;
		fscanf(fpTopo, "%ld %lf %lf %lf %ld %lf %lf %lf", 
			&wNum, &wUpX, &wUpY, &wUpZ, &wNum, &wLowX, &wLowY, &wLowZ);
		mX = 0.5 * (wUpX + wLowX);
		mY = 0.5 * (wUpY + wLowY);
		mZ = 0.5 * (wUpZ + wLowZ);
	}
	else
	{
//		mX = mY = mZ = 0.0;
		fprintf(stderr, "E: data format error");
		exit(1);
	}

	// 㗬GbW̐ǂݍ()
	assert(fscanf(fpTopo, "%d", &numberOfUpperEdges) == 1);
	assert(numberOfUpperEdges >= 0);

	// upperEdgeNumArray, upperEdgeArray ̊m
	if (numberOfUpperEdges > 0) 
	{
		upperEdgeNumArray = new long[numberOfUpperEdges];
		upperEdgeArray = new Edge*[numberOfUpperEdges];
	}
	else						// numberOfUpperEdges == 0
	{
		upperEdgeNumArray = new long;
		upperEdgeArray = new Edge*;
	}

	// upperEdgeArray ̏
	for (int i = 0; i < numberOfUpperEdges; i++)
		upperEdgeArray[i] = NULL;

	// 㗬GbW̔ԍǂݍ()
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
		long num;
		assert(fscanf(fpTopo, "%ld", &num) == 1);
		upperEdgeNumArray[i] = num;
	}

	// GbW̐ǂݍ()
	int tmp;
	assert(fscanf(fpTopo, "%d", &tmp) == 1);
	assert(tmp >= 0);

	// GbW̔ԍǂݍ()

	Boolean outEdgeFromLowerEnd = (Boolean)NO;
	// [痬oGbWꍇ YES

	for (int i = 0; i < tmp; i++)
	{
		long num;
		assert(fscanf(fpTopo, "%ld", &num) == 1);
		if (num < 0) outEdgeFromLowerEnd = (Boolean)YES;
	}

	// GbW̑ǂݍ()

	assert(fscanf(fpTopo, "%d", &tmp) == 1);
	assert(tmp == 1 || tmp == 2);
	mAtr = tmp;

	// ŉ[̃GbWǂmF
	if (mAtr == 2 && outEdgeFromLowerEnd == (Boolean)NO) // ŉ[GbW
		lowestEdge = (Boolean)YES;
	else 
		lowestEdge = (Boolean)NO;

	// mAtr  1 ̂Ƃ(_-_GbŴƂ)
	// GbW̒AzAʐςǂݍ()

	if (mAtr == 1)
	{
		double wlen, wgrd, warea;
		assert(fscanf(fpTopo, "%lf %lf %lf", &wlen, &wgrd, &warea)
			   == 3);
		assert(wlen > 0.0);
		assert(wgrd > 0.0);
		assert(warea > 0.0);

		mArea = warea;
		mWidth = mArea / wlen;

// 		printf("wlen : %f\n", wlen);
// 		printf("wgrd : %f\n", wgrd);

		// wlen ͐Ȃ̂3ɕϊ
		mL = wlen * sqrt(1.0 + wgrd*wgrd);

// 		printf("mL : %f\n", mL);

		// wgrd  tangent ̒lȂ̂ŁAsin ̒lɕϊ
		wgrd = atan(wgrd);
		mGrd = sin(wgrd);

		// mCos ߂BmCos ͍~xɏ悶
		mCos = cos(asin(mGrd));
	}

  

	// ʕzA㗬̖ʐςǂݍ(V.3/5)
	if (wTopoDataType == 3 || wTopoDataType == 5)
 	{
	
	  assert(fscanf(fpTopo, "%lf %lf", &mDist, &mUpperArea) == 2);
		assert(mDist > 0.0);
		assert(mUpperArea >= 0.0);

// 		// for debugging
// 		printf("%ld %f %f\n", mNum, mDist, mUpperArea);



        
	}

// 	// for debugging
//  	printf("%ld : %d %f %f %f %f %f %d %d\n",
//  		mNum, mAtr, mL, mArea, mWidth, mGrd, mCos,
//  		   numberOfUpperEdges, lowestEdge);
}

void Edge::DistributionRate(void)
{
	if (mAtr == 2)				// _-͓_GbW̏ꍇ
	{
		int couter = 1;	// ܂߂㗬GbW̐
		for (int i = 0; i < numberOfUpperEdges; i++)
		{
			if (upperEdgeNumArray[i] < 0) // 㗬GbW
									      // ݂
			{
				couter++;
			}
		}

		mDist = 1.0 / couter;
		return ;
	}

	// _-_GbW̏ꍇ

	// $mDist = mWidth \sqrt(mGrd) / 
	// 		\sum_{m=1}^{N} mWidth_{m} \sqrt(mGrd_{m})

	double tmpa, tmpb;
	tmpa = tmpb = mWidth * sqrt(mGrd);

	int counter = 1;				// 㗬GbW̐

	Boolean anyBRedge = (Boolean)NO;
	// 㗬GbWɈł_-͓_GbW݂
	// ꍇAYES 

	for (int i = 0; i < numberOfUpperEdges; i++)
	{
//		printf("%ld : %ld\n", mNum, upperEdgeArray[i]->Num());

		// 㗬GbW݂
		if (upperEdgeNumArray[i] < 0)
		{
			counter++;

			// GbW_-_GbWłꍇ
			if (upperEdgeArray[i]->Atr() == 1)
			{
				tmpb += upperEdgeArray[i]->Width() * 
					sqrt(upperEdgeArray[i]->Gradient());
			}
			else if (upperEdgeArray[i]->Atr() == 2)
			{
				anyBRedge = (Boolean)YES;
			}
		}
	}

	if (anyBRedge == (Boolean)NO)
	{
		mDist = tmpa / tmpb;
	}
	// 㗬GbWɈł_-͓_GbW݂
	// ꍇ́A̎gȂ̂ŁAPɓŊ 
	else
		mDist = 1.0 / counter;

// 	// for debugging
// 	printf("%ld %f\n", mNum, mDist);
}

void Edge::CalcUpperArea(void)
{
// 	if (mAtr == 2)				// _-͓_GbW̏ꍇ
// 	{
// 		mUpperArea = 0.0;
// 
// // 		// for debugging
// // 		printf("%ld %f %f\n", mNum, mDist, mUpperArea);
// 
// 		return ;
// 	}
// 
// 	// _-_GbW̏ꍇ

	// 㗬痬GbW n Ƃ
	// $mUpperArea = \sum_{i=1}^{n}(mUpperArea_i + mArea_i) \times mDist$

	mUpperArea = 0.0;
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
//		printf("%ld : %ld\n", mNum, upperEdgeArray[i]->Num());

		// 㗬痬GbW݂
		if (upperEdgeNumArray[i] > 0)
		{
			// GbW_-_GbWłꍇ
			if (upperEdgeArray[i]->Atr() == 1)
			{
				mUpperArea += upperEdgeArray[i]->Area() +
					upperEdgeArray[i]->UpperArea();
			}
			else if (upperEdgeArray[i]->Atr() == 2)
			{
				cerr << "wrong connection of edges:" << endl;
				cerr << "from " << upperEdgeArray[i]->Num() << " to "
					 << Num() << endl;
				exit(1);
			}
		}
	}

	mUpperArea *= mDist;

// 	// for debugging
// 	printf("%ld %f %f\n", mNum, mDist, mUpperArea);
}

void Edge::Discharge
(
	double disUpperEnd,			// [ł̗
	double disLowerEnd			// [ł̗
)
{
	mQc[0] = mQn[0] = disUpperEnd;
	mQc[mN] = mQn[mN] = disLowerEnd;

	// ̌vZfʂ̗ʂ`Ԃŋ߂
	for (int i = 1; i <= mN-1; i++)
	{
		mQc[i] = mQn[i] = mQc[0] + 
			(mQc[mN] - mQc[0]) / (double)mN * (double)i ;
	}
}

void Edge::Discharge
(
	double* disUpperEnd,			// [ł̗
	double* disLowerEnd				// [ł̗
)
{
	*disUpperEnd = mQc[0];
	*disLowerEnd = mQc[mN];
}

void Edge::CalcSatArea
(
 void
)
{
	// Oa̖ʐς̌vZ
	mSarea = 0.0;
	double wQsat = mA * mWidth * mDepth;
	for (int i = 1; i <= mN; i++)
	{
		// ԏ[ŖOa
		if (mQn[i-1] >= wQsat)
		{
			// ԉ[łOa
			if (mQn[i] >= wQsat)
				mSarea += mWidth * mDx;
			// [ł͕sOa
			else
				mSarea += mWidth * mDx * 
					(wQsat - mQn[i-1]) / (mQn[i] - mQn[i-1]);
		}
		// [ł͕sOa
		else
		{
			// [ł͖Oa
			if (mQn[i] >= wQsat)
				mSarea += mWidth * 
					(mDx - mDx * (wQsat - mQn[i-1]) / (mQn[i] - mQn[i-1]));
			// [ł͕sOa
			else
				mSarea += 0.0;
		}
	}

	// added by Yutaka ICHIKAWA (Wed Sep  8 11:23:14 1999)
	mSarea *= mCos;
}

// void Edge::CalcStorage
// (
//  void
// )
// {
// // 	for (int i = 0; i <= mN; i++)
// // 	{
// // 		printf("%f ", mQn[i]);
// // 	}
// // 	printf("\n");
// 
// 	double* wHn = new double[mN+1];
// 	for (int i = 0; i <= mN; i++)
// 	{
// 		// added by Yutaka ICHIKAWA 
// 		// Fri Sep 17 12:04:31 1999
// 		if (mQn[i] < 0.00000001) 
// 			wHn[i] = 0.0;
// //		if (mQn[i]/mWidth <= mA * mDepth) // ԗ̏ꍇ
// 		else if (mQn[i]/mWidth < mA * mDepth) // ԗ̏ꍇ
// 			wHn[i] = mQn[i]/mWidth/mA;
// 		else
// 		{
// 			// ĺAah  ad ŋߎċ߂܂
// 			double h0 =
// 				mDepth + pow(((mQn[i]/mWidth - mA * mDepth)/mAlpha),1./mM);
// 			double v0 = pow(h0 - mDepth, mM - 1.);
// 			double q0 = mAlpha * v0 * (h0 - mDepth) + mA * h0;
// 			double q1;
// 
// 			while (1)
// 			{
// 				h0 = h0 - (q0 - mQn[i]/mWidth)/(mAlpha * mM * v0 + mA);
// 				v0 = pow(h0 - mDepth, mM - 1.);
// 				q1 = mAlpha * v0 * (h0 - mDepth) + mA * h0;
// 				if (q1 > q0 - 0.0000001) break;
// 				q0 = q1;
// 			}
// 
// 			wHn[i] = h0;
// 		}
// 
// //		printf("%f ", wHn[i]);
// 	}
// 
// //	printf("\n");
// 
// 	mStorage = 0.0;
// 	for (int i = 1; i <= mN; i++)
// 	{
// 		mStorage += (wHn[i-1]+wHn[i]) * mDx * 0.5 * mWidth;
// 	}
// 
// //	printf("%f\n", mStorage);
// 	delete [] wHn;
// }

//void Edge::CalcStorage
//(
// void
//)
//{
//	double* wHn = new double[mN+1];
//	for (int i = 0; i <= mN; i++)
//	{
//		// added by Yutaka ICHIKAWA 
//		// Fri Sep 17 12:04:31 1999
//		if (mQn[i] < 0.00000001) 
//			wHn[i] = 0.0;
//		else if (mQn[i]/mWidth < mA * mDepth) // ԗ̏ꍇ
//		{
//			double wHf = mQn[i]/mWidth/mA;
//			wHn[i] = wHf + 
//				mHc * pow(1.0-pow((mDepth-wHf)/mDepth, mNf), 1.0/mNf);
//		}
//		else
//		{
//			// ĺAah  ad ŋߎċ߂܂
//			double hf0 =
//				mDepth + pow(((mQn[i]/mWidth - mA * mDepth)/mAlpha),1./mM);
//			double v0 = pow(hf0 - mDepth, mM - 1.);
//			double q0 = mAlpha * v0 * (hf0 - mDepth) + mA * hf0;
//			double q1;

//			while (1)
//			{
//				hf0 = hf0 - (q0 - mQn[i]/mWidth)/(mAlpha * mM * v0 + mA);
//				v0 = pow(hf0 - mDepth, mM - 1.);
//				q1 = mAlpha * v0 * (hf0 - mDepth) + mA * hf0;
//				if (q1 > q0 - 0.0000001) break;
//				q0 = q1;
//			}

//			wHn[i] = hf0 + mHc;
//		}

////		printf("%f ", wHn[i]);
//	}

////	printf("\n");

//	mStorage = 0.0;
//	for (int i = 1; i <= mN; i++)
//	{
//		mStorage += (wHn[i-1]+wHn[i]) * mDx * 0.5 * mWidth;
//	}

////	printf("%f\n", mStorage);
//	delete [] wHn;
//}


///////////////////////////////////////////////////////////////////////////////
//y됅̖OaEsOalkinematic wave@ modified by NAGATANI Aug. 2002///
void Edge::CalcStorage
(
 void
)
{
    double beta = mNf;

	double* wHn = new double[mN+1];
	for (int i = 0; i <= mN; i++)
	{
        // added by Yutaka ICHIKAWA 
        // Fri Sep 17 12:04:31 1999

        // mGammae = mGamma - mGammac;
        // mNf = nf;
        // mAlpha = sqrt(mGrd) / mMan;
        // mA = mK * mGrd / mGammae;
        // mDepth = mD * mGammae;
        // mHc = mD * mGammac;

		if (mQn[i] < 0.00000001) 
			wHn[i] = 0.0;
		else if (mQn[i]/mWidth < mA/beta * mHc) // }gNX̏ꍇ
		{
		  wHn[i] = pow((mQn[i]/mWidth)*beta /(mHc*mA),1/beta)*mHc;
		}
        else if (mQn[i]/mWidth < mA/beta * mHc + mA * mDepth) // }gNX{ԗ̏ꍇ
          wHn[i] = mHc + (mQn[i]/mWidth -  mA/beta * mHc) /mA;   
		else
		{
			// ĺAah  ad ŋߎċ߂܂
			double h0 =	
          mDepth + mHc + pow(((mQn[i]/mWidth - (mA * mDepth + mA/beta * mHc))/mAlpha),1./mM);
			double v0 = pow(h0 - (mDepth+mHc), mM - 1.);
			double q0 = mAlpha * v0 * (h0 - (mDepth+mHc)) + mA * (h0 - mHc) + mA/beta * mHc;
			double q1;

			while (1)
			{
				h0 = h0 - (q0 - mQn[i]/mWidth)/(mAlpha * mM * v0 + mA);
				v0 = pow(h0 - (mDepth+mHc), mM - 1.);
				q1 = mAlpha * v0 * (h0 - (mDepth+mHc)) + mA * (h0 - mHc) + mA/beta * mHc;
				if (q1 > q0 - 0.0000001) break;
				q0 = q1;
			}
      wHn[i] = h0;
			//wHn[i] = h0 + mHc;
		}

//		printf("%f ", wHn[i]);
	}

//	printf("\n");

	mStorage = 0.0;
	for (int i = 1; i <= mN; i++)
	{
		mStorage += (wHn[i-1]+wHn[i]) * mDx * 0.5 * mWidth;
	}

//	printf("%f\n", mStorage);
	delete [] wHn;
}
///////////////////////////////////////////////////////////////////////////////

Boolean Edge::Calculate
(
	double r					// ~x (mm/hour)
)
{
	// upstream end
	mQn[0] = 0.0;
	for (int i = 0; i < numberOfUpperEdges; i++)
	{
		if (upperEdgeNumArray[i] > 0) // GbW
		{
			mQn[0] += upperEdgeArray[i]->DischargeLowerEnd();
		}
	}
	mQn[0] *= mDist;			// ʕz

	if (mAtr == 2)				// _-͓_GbW̏ꍇ
	{
		mQc[mN] = mQn[0];
		return (Boolean)YES;
	}

	double dta = mDt;			// time step (s)

	// lateral inflow
	double rLin = r * 0.001 / 3600.0 * mCos; // ~x (m/s)

	double cold; // double cnew; 
	double inflow_area = mUpperArea;

	for (int i = 1; i <= mN; i++)
	{
		double wm = mWidth;
		inflow_area += wm * mDx;
		double delta_q = mQsmall * inflow_area;
		double q = 0.5 * (mQc[i-1] + mQc[i]) / wm;

//		cold = PropagationSpeed(alpha, a, d, delta_q / wm, q);
		cold = PropagationSpeed(mAlpha, mA, mDepth, mHc, mNf,
								mM, delta_q / wm, q);
		if (cold < mCmin) cold = mCmin;

		mQn[i] = (mQc[i] + mTheta * cold * 
			(dta/mDx * mQn[i-1] + dta * wm * rLin) - 
			(1. - mTheta) * cold * dta * 
			((mQc[i] - mQc[i-1])/mDx - rLin * wm)) / 
			(1. + mTheta * cold * dta / mDx);

		if (mQn[i] < 0.)
		{
			fprintf(stderr, "W: Negative discharge\n");
			fprintf(stderr, "mQn[i] : %f\n", mQn[i]);
			mQn[i] = 0.;
		}
	}

	// Oa̖ʐς̌vZ
	CalcSatArea();

	// for debugging
	CalcStorage();

	// update state variables
	for (int i = 0; i <= mN; i++)
	{
		mQc[i] = mQn[i];
	}

	return (Boolean)YES;
}

// double Edge::PropagationSpeed // `dx c vZĕԂ
// (
//     double aAlpha,	    // p^ $\alpha$
//     double aA,		    // p^ a
//     double aDepth,	    // p^ d
//     double aQeps,	    // l
//     double aQunit	    // Pʕ̗
//     //
//     // $q = \alpha (h - d)^m + a h$
//     // $c = dq/dh = \alpha m (h - d)^(m-1) + a$
//     //
//     )
// {
// 	// Newton @ŁAΉ h ̒l߂ĂA`dxvZ
// 	// B
// 
// 	if (aQunit <= aA * aDepth) // ԗ̏ꍇ
// 	{
// 		return aA;
// 	}
// 
// 	double h0 =
// 		aDepth + pow(((aQunit - aA * aDepth)/aAlpha),1./mM);
//     	// ĺAah  ad ŋߎċ߂܂
// 	double v0 = pow(h0 - aDepth, mM - 1.);
// 	double q0 = aAlpha * v0 * (h0 - aDepth) + aA * h0;
// 	double q1;
// 
// 	while (1)
// 	{
// 		h0 = h0 - (q0 - aQunit)/(aAlpha * mM * v0 + aA);
// 		v0 = pow(h0 - aDepth, mM - 1.);
// 		q1 = aAlpha * v0 * (h0 - aDepth) + aA * h0;
// 		if (q1 > q0 - aQeps) break;
// 		q0 = q1;
// 	}
// 
// 	double c = aAlpha * mM * v0 + aA;
// 	return c;
// }

//double Edge::PropagationSpeed // aQunit ɑΉ`dx c vZĕԂ
//(
//   	double aAlpha,  // p^ $\alpha$
//	double aA,	    // p^ a
//	double aDepth,  // p^ d
//	double aHc,		// 
//	double aNf,		// Nf (-)
//	double aM,		// kinematic routing parameter (-)
 //  	double aQeps,   // l
//   	double aQunit   // Pʕ̗
//)
//{
//// 	if (aQunit <= aA * aDepth) // ԗ̏ꍇ
//	if (aQunit < aA * aDepth) // ԗ̏ꍇ
//	{
//		if (aHc == 0.0) return aA; // ޏeʂ 0 ̏ꍇ c = aA

//		double wHf = aQunit / aA; // R
//		double wMu = (aDepth - wHf) / aDepth;

//		return aA * pow(1.0-pow(wMu, aNf), (aNf-1.0)/aNf) /
//			(pow(1.0-pow(wMu, aNf), (aNf-1.0)/aNf) +
//			 aHc/aDepth*pow(wMu, aNf-1.0));
//	}

//	// \ʗĂꍇ

//   	// ĺAa*hf  a*d ŋߎċ߂܂
//	double hf0 =
//		aDepth + pow(((aQunit - aA*aDepth)/aAlpha),1./aM);

//	double v0 = pow(hf0 - aDepth, aM - 1.);
//	double q0 = aAlpha * v0 * (hf0 - aDepth) + aA * hf0;
//	double q1;

//	while (1)
//	{
//		hf0 = hf0 - (q0 - aQunit)/(aAlpha * aM * v0 + aA);
//		v0 = pow(hf0 - aDepth, aM - 1.);
//		q1 = aAlpha * v0 * (hf0 - aDepth) + aA * hf0;
//		if (q1 > q0 - aQeps) break;
//		q0 = q1;
//	}

//	double c = aAlpha * aM * v0 + aA;
//	return c;
//}


////////////////////////////////////////////////////////////////////////////
//y됅̖OaEsOalkinematic wave@ modified by NAGATANI Aug. 2002///
double Edge::PropagationSpeed // aQunit ɑΉ`dx c vZĕԂ
(
   	double aAlpha,  // p^ $\alpha$
	double aA,	    // p^ a
	double aDepth,  // p^ d
	double aHc,		// D * Gammac
	double aNf,		// Nf (-)
	double aM,		// kinematic routing parameter (-)
   	double aQeps,   // l
   	double aQunit   // Pʕ̗
)
{ 

  double beta = aNf;

  if (aQunit < aA/beta * aHc) //}gNX̏ꍇ
  {

     double h = pow(aQunit*beta /(aA*aHc),1/beta) * aHc; 
     
     return aA * pow(h/aHc , beta - 1.);
  } 
  else if (aQunit < aA * aDepth + aA/beta * aHc) // }gNXEԗ̏ꍇ
  {
     return aA;
  }

  // \ʗĂꍇ ĺAa*hf  a*d ŋߎċ߂܂
  double h0 =
           aDepth + aHc + pow(((aQunit - (aA*aDepth + aA/beta *aHc))/aAlpha),1./aM);

  double v0 = pow(h0 - (aDepth+aHc), aM - 1.);
  double q0 = aAlpha * v0 * (h0 - (aDepth+aHc)) + aA * (h0 - aHc) + aA/beta * aHc;
  double q1;

  while (1)
  {
     h0 = h0 - (q0 - aQunit)/(aAlpha * aM * v0 + aA);
     v0 = pow(h0 - (aDepth+aHc), aM - 1.);
     q1 = aAlpha * v0 * (h0 - (aDepth+aHc)) + aA * (h0 - aHc) + aA/beta * aHc;
     if (q1 > q0 - aQeps) break;
     q0 = q1;
  }

  double c = aAlpha * aM * v0 + aA;
  return c;
}
///////////////////////////////////////////////////////////////////////////////

//                                                      //
// --- 牺 KsEdgeFc2d Ɋւ implementation --- //
//                                                      //

KsEdgeFc2d::KsEdgeFc2d(char* o_name, int o_num) : Element()
{
	class_name = "KsEdgeFc2d";
	Init(o_name, o_num);
}

Boolean KsEdgeFc2d::Init(char* o_name, int o_num)
{
	// rp,sp ̏
	rp.Init("rp", 0);
	sp.Init("sp", 0);
	spSarea.Init("spSarea", 0);
	spStorage.Init("spStorage", 0);

	mSumRain = 0.0;
	mSumQout = 0.0;
	mStorage = 0.0;

	return Element::Init(o_name, o_num);
}

KsEdgeFc2d::KsEdgeFc2d(void) : Element()
{
	class_name = "KsEdgeFc2d";
}

void KsEdgeFc2d::Set_parameter(FILE* fp)
{
	int dt;						// time_step (s)

	char s1[256], s2[256];		// s1 : edge connection t@C
								// s2 : Wꂽt@C
 
	double xorig, yorig;		// 2~Jf[^̌_W (m)
	double dx, dy;				// 2~Jf[^̋ԊԊu (m)

	if (fscanf(fp, "%d %s %s %lf %lf %lf %lf", 
		&dt, s1, s2, &xorig, &yorig, &dx, &dy) != 7)
	{
		Eprint(__FILE__, __LINE__);
			// KsEdgeFc2d::Set_parameter
			// can not read parameter file.
		Oprint();
		exit(1);
	}

	assert(dt > 0); mDt = dt;
	assert(dx > 0.0); mDx = dx;
	assert(dy > 0.0); mDy = dy;

	mXorig = xorig;
	mYorig = yorig;

	// GbW̌vZɕׂꂽ edge connection V.? t@C
	// ǂݍ

	FILE* fpTopo;
	assert((fpTopo = dataFileOpen(s1)) != NULL);

	// [Data Format Name]: mTopoDataType ̐ݒ

	char buf[256];
	while (fgets(buf, 256, fpTopo) != NULL &&
		   strncmp(buf, "[Data Format Name]", 18) != 0) ;
	fgets(buf, 256, fpTopo);
	if (strncmp(buf, "edge connection V.2", 19) == 0)
	{
		mTopoDataType = 2;
	}
	else if (strncmp(buf, "edge connection V.3", 19) == 0)
	{
		mTopoDataType = 3;
	}
	else if (strncmp(buf, "edge connection V.4", 19) == 0)
	{
		mTopoDataType = 4;
	}
	else if (strncmp(buf, "edge connection V.5", 19) == 0)
	{
		mTopoDataType = 5;
	}
	else
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdgeFc2d::Set_parameter
			// Invalid topographic data format.
			// Topographic data must be edge connection V.{2/3/4/5} format.
		Oprint();
		exit(1);
	}

	while (fgets(buf, 256, fpTopo) != NULL &&
		   strncmp(buf, "[Number of Total Edges]", 23) != 0) ;

	long numEdges;				// GbW̐
	fgets(buf, 256, fpTopo);
	assert(sscanf(buf, "%ld", &numEdges) == 1);
	assert(numEdges > 0); numberOfEdges = numEdges;
	assert((edgeArray = new Edge[numberOfEdges]) != NULL);

	while (fgets(buf, 256, fpTopo) != NULL &&
		   strncmp(buf, "[Data]", 6) != 0) ;

	double totalArea = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		edgeArray[i].TopographicData(fpTopo, mTopoDataType);
		if (edgeArray[i].Atr() == 1) // _-_
			totalArea += edgeArray[i].Area();
	}
	fclose(fpTopo);
	Oprint();
	cout << "\ttotal area: " << totalArea << "(m2)" << endl;

	// GbWԍL[ɂăoCic[

	for (long i = 0; i < numberOfEdges; i++)
	{
		long num = edgeArray[i].Num();
		treeKeyedByEdgeNumber.Insert(num, &edgeArray[i]);
	}

	// ̌vZɕKvȃp^lǂݍ

	FILE* fpParam;
	assert((fpParam = dataFileOpen(s2)) != NULL);

	// [Data Format Name]
	while (fgets(buf, 256, fpParam) != NULL &&
		   strncmp(buf, "[Data Format Name]", 18) != 0) ;
	fgets(buf, 256, fpParam);
	if (strncmp(buf, "KsEdgeFc Parameter Format", 23) != 0)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdgeFc2d::Set_parameter
			// Invalid data format.
		Oprint();
		exit(1);
	}

	// [Number of Total Edges]
	long numtmp;
	while (fgets(buf, 256, fpParam) != NULL &&
		   strncmp(buf, "[Number of Total Edges]", 23) != 0) ;
	fgets(buf, 256, fpParam);
	assert(sscanf(buf, "%ld", &numtmp) == 1);
	if (numtmp != numberOfEdges)
	{
		Eprint(__FILE__, __LINE__);
			// KsEdgeFc2d::Set_parameter
			// Wrong number of total edges given in 
		fprintf(stderr, "%s.\n", s2);
		Oprint();
		exit(1);
	}

	// [Data]
	while (fgets(buf, 256, fpParam) != NULL &&
		   strncmp(buf, "[Data]", 6) != 0) ;

	long num;					// GbWԍ
	double man;					// }jȎexW (m-s)
	double m;					// 
	double k;					// W (m/s)
	double d;					// Aw (m)
	double gamma;				// S󌄗 (-)
	double gammac;				// ޏe (-)
 	double nf;		            // SʂƎRʂ̊֌W̃p
								// ^
	double theta;				// (-)
	double cmin;				// minimun C = dQ/dA (m/s)
	double Qlevel;				// (mm/hour)
	double eps;					// (-)
	int ndiv;					// ԕ (-)

	for (long i = 0; i < numberOfEdges; i++)
	{
// 		if (fscanf(fpParam, "%ld %lf %lf %lf %lf %lf %lf %lf %lf %lf %d",
// 				   &num, &man, &m, &k, &d, &gamma, &theta, &cmin,
// 				   &Qlevel, &eps, &ndiv) != 11)


	  //		if (fscanf(fpParam, "%ld %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %d",
	  //			   &num, &man, &m, &k, &d, &gamma, &gammac, &nf, &theta, &cmin,
	  //			   &Qlevel, &eps, &ndiv) != 13)

	  double ks_tmp;                // ^̓W  (m/s) modified by Tachikawa
	  double d_tmp;                 // ^ Aw (m)
	  double hc_tmp;		// ޏeʂɑΉ鐅[ (m)
//	  double beta;     //sOaWƖOaW̊֌W\W@Ks = Beta * Kc (-)

		if (fscanf(fpParam, "%ld %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %d",
				   &num, &man, &m, &ks_tmp, &d, &d_tmp, &hc_tmp, &nf, &theta, &cmin,
				   &Qlevel, &eps, &ndiv) != 13)

		  //gamma = (d_tmp + hc_tmp)/d;
 		  //gammac = hc_tmp/d;
                  //k = ks_tmp*gamma; 
//       beta = nf;

		{
			Eprint(__FILE__, __LINE__);
				// KsEdgeFc2d::Set_parameter
				// can not read parameter file.
			fprintf(stderr, "File: %s\n", s2);
			Oprint();
			exit(1);
		}
		gamma = (d_tmp + hc_tmp)/d;  //added by Tachikawa 
		gammac = hc_tmp/d;        
		k = ks_tmp*(gamma-gammac);  

		assert(num > 0);
		assert(man > 0.0);
		assert(m >= 1.0);
		assert(k >= 0.0);
		assert(d >= 0.0);
		assert(0.0 < gamma && gamma <= 1.0);
		assert(0.0 <= gammac && gammac < gamma);
		assert(nf > 1.0);
		assert(0.0 <= theta && theta <= 1.0);
		assert(cmin > 0.0);
		assert(Qlevel > 0.0);
		assert(eps > 0.0);
		assert(ndiv > 0);

		KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
		if (pi == NULL)
		{
			Eprint(__FILE__, __LINE__);
				// KsEdgeFc2d::Set_parameter
			fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
			Oprint();
			exit(1);
		}

		Edge* p = pi->Data();
// 		p->ParametersInFlowModel(man, m, k, d, gamma, theta, cmin,
// 								 Qlevel, eps, ndiv, dt);
		p->ParametersInFlowModel(man, m, k, d, gamma, gammac, nf, theta, cmin,
					 Qlevel, eps, ndiv, dt); //y됅̖OaEsOalkinematic wave@
	}

	fclose(fpParam);

	// upperEdgeArray 

	for (long i = 0; i < numberOfEdges; i++)
	{
		int upnum = edgeArray[i].NumberOfUpperEdges();
		for (int j = 0; j < upnum; j++)
		{
			long num = abs(edgeArray[i].UpperEdgeNumArray(j));
			KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
			if (pi == NULL)
			{	
				Eprint(__FILE__, __LINE__);
					// KsEdgeFc2d::Set_parameter
				fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
				Oprint();
				exit(1);
			}

			Edge* p = pi->Data();
			assert(edgeArray[i].RegisterUpperEdge(p) == (Boolean)YES);
		}
	}

	// n`f[^ edge connection V.2 邢 V.4 Ȃ΁A
	// GbW DistributionRate, CalcUpperArea 
	// edge connection V.3  V.5 Ȃ mSumArea vZ

	mSumArea = 0.0;

	if (mTopoDataType == 2 || mTopoDataType == 4)
	{
		for (long i = 0; i < numberOfEdges; i++)
		{
			edgeArray[i].DistributionRate();
			edgeArray[i].CalcUpperArea();
			mSumArea += edgeArray[i].Area();
		}
	}
	else if (mTopoDataType == 3 || mTopoDataType == 5)
	{
		for (long i = 0; i < numberOfEdges; i++)
		{
			mSumArea += edgeArray[i].Area();
		}
	}
	else 
	{
		Eprint(__FILE__, __LINE__);
			// invalid data format
		Oprint();
		exit(1);
	}

	// Wed Aug 18 21:18:47 1999
	// rp Ŏ󂯎̂ step ̃f[^
//	rp.Set_data_connection_type(1);
	// 0Ȃ܂A
	// 1Ȃ stepA
	// 2Ȃ pulse
}

void KsEdgeFc2d::Set_initial_state(FILE* fp)
{
	if (fscanf(fp, "%ld %s", &current_time, edgeDisFileName) != 2)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdgeFc2d::Set_initial_state
			// Cannot read initial state file.
		Oprint();
		exit(1);
	}

	FILE* fpDis;
	char buf[256];
	assert((fpDis = dataFileOpen(edgeDisFileName)) != NULL);

	// [Data Format Name]
	while (fgets(buf, 256, fpDis) != NULL &&
		   strncmp(buf, "[Data Format Name]", 18) != 0) ;
	fgets(buf, 256, fpDis);
	if (strncmp(buf, "KsEdgeFc Initial State Format", 27) != 0)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdgeFc2d::Set_initial_state
			// Invalid data format.
		Oprint();
		exit(1);
	}

	// [Number of Total Edges]
	long numtmp;
	while (fgets(buf, 256, fpDis) != NULL &&
		   strncmp(buf, "[Number of Total Edges]", 23) != 0) ;
	fgets(buf, 256, fpDis);
	assert(sscanf(buf, "%ld", &numtmp) == 1);
	if (numtmp != numberOfEdges)
	{
		Eprint(__FILE__, __LINE__);
	    	// KsEdgeFc2d::Set_initial_state
			// Wrong number of total edges given in 
			fprintf(stderr, "%s.\n", edgeDisFileName);
		Oprint();
		exit(1);
	}

	// [Data]
	while (fgets(buf, 256, fpDis) != NULL &&
		   strncmp(buf, "[Data]", 6) != 0) ;

	for (long i = 0; i < numberOfEdges; i++)
	{
		long num;
		double updis, lowdis;
		if (fscanf(fpDis, "%ld %lf %lf", &num, &updis, &lowdis) != 3)
		{
			Eprint(__FILE__, __LINE__);
				// KsEdgeFc2d::Set_initial_state
				// can not read discharge file.
			fprintf(stderr, "File: %s\n", edgeDisFileName);
			Oprint();
			exit(1);
		}

		assert(num > 0);
		assert(updis >= 0.0);
		assert(lowdis >= 0.0);

		KeyData* pi = treeKeyedByEdgeNumber.GetPtrToData(num);
		if (pi == NULL)
		{
			Eprint(__FILE__, __LINE__);
				// KsEdgeFc2d::Set_initial_state
			fprintf(stderr, "Edge %ld was not found in edgeArray\n", num);
			Oprint();
			exit(1);
		}

		Edge* p = pi->Data();
		p->Discharge(updis, lowdis);
		p->CalcSatArea();
	}

	fclose(fpDis);
}

void KsEdgeFc2d::Save_terminal_state(FILE* fp)
{
	assert(fp != NULL);

	// GbW̏㉺[̗ʂL^t@C̖O
	// 
// 	char s[256]; char* p = s;
// 	p = chgex(edgeDisFileName, "tst");
// 	// chgex ̓t@C̊gqύX֐łB
// 	// chgex.h Œ`Ă܂B

	char s[256];
	strcpy(s, edgeDisFileName);
	strcat(s, ".tst");

// 	fprintf(fp, "%ld %f %s\n", current_time, mRainc, p);
	fprintf(fp, "%ld %s\n", current_time, s);

	FILE* fpDis;
//	fpDis = fopen(p, "w");
	fpDis = fopen(s, "w");

	char* commentSection = "[Comment]\nThese are discharge data at both ends of all edges.\nEach column in [Data] section is as follows:\n<edge number>\n<discharge at upper end(m3/s)>\n<discharge at lower end(m3/s)>\n" ;
	char* dataFormatNameSection = "[Data Format Name]\nKsEdgeFc2d Initial State Format\n";
	char* numberOfTotalEdgesSection = "[Number of Total Edges]\n";
	char* dataSection = "[Data]\n";

	fprintf(fpDis, "%s", commentSection);
	fprintf(fpDis, "%s", dataFormatNameSection);
	fprintf(fpDis, "%s", numberOfTotalEdgesSection);
	fprintf(fpDis, "%ld\n", numberOfEdges);
	fprintf(fpDis, "%s", dataSection);

	for (long i = 0; i < numberOfEdges; i++)
	{
		long num = edgeArray[i].Num();
		double updis, lowdis;
		edgeArray[i].Discharge(&updis, &lowdis);
		fprintf(fpDis, "%ld %f %f\n", num, updis, lowdis);
	}

	fclose(fpDis);
}

Boolean KsEdgeFc2d::Initial_output(void)
{
	long CELLBLK = 5;			// 5x5  1 ubNƂ

	// eΖʑfЂǂ̊iqZf[^擾邩ׂĂ

	void* fdp; void* ldp;
	if (rp.Get_data_pack(fdp, current_time, ldp) == NO)
		return NO;

	// Jʃf[^ėāAsƗ̌𒲂ׂ
	time_t wt;
	KhDMatrix wRain;

	if (fdp != NULL)
	{
		wt = ((Data<KhDMatrix>*)fdp)->Data_time();
		wRain = ((Data<KhDMatrix>*)fdp)->Value();
	}
	else if (ldp != NULL)
	{
		wt = ((Data<KhDMatrix>*)ldp)->Data_time();
		wRain = ((Data<KhDMatrix>*)ldp)->Value();
	}
	else return NO;

	// ׂZ̐
	long xCellNum = wRain.GetRows(); // x 
	long yCellNum = wRain.GetCols(); // y 

// 	// for debugging
// 	printf("xCellNum: %ld, yCellNum: %ld\n", xCellNum, yCellNum);

	if (xCellNum < CELLBLK || yCellNum < CELLBLK)
	{
		CELLBLK = (xCellNum < yCellNum) ? xCellNum : yCellNum ;
	}

// 	// for debugging
// 	printf("CELLBLK: %ld\n", CELLBLK);

	// 傫ȃZ(ZubN)̐
	long xBlkNum = (xCellNum%CELLBLK == 0)? 
		xCellNum/CELLBLK : xCellNum/CELLBLK + 1 ;
	long yBlkNum = (yCellNum%CELLBLK == 0)? 
		yCellNum/CELLBLK : yCellNum/CELLBLK + 1 ;

// 	// for debugging
//  	printf("xBlkNum: %ld, yBlkNum: %ld\n", xBlkNum, yBlkNum);

	for (long m = 0; m < numberOfEdges; m++)
	{
		// _-_GbWȊO̓XLbv
		if (edgeArray[m].Atr() != 1) continue;

		// edgeArray[m] ̈ʒu
		double x = edgeArray[m].X();
		double y = edgeArray[m].Y();

		double xl, xu, yl, yu;

		// ǂ̃ZubNɂ邩T
		for (long I = 0; I < xBlkNum; I++)
		{
			xl = mXorig+(double)I*(double)CELLBLK*mDx;
			xu = mXorig+(double)(I+1)*(double)CELLBLK*mDx;

// 			// for debugging
// 			printf("xl: %f, xu: %f\n", xl, xu);

			for (long J = 0; J < yBlkNum; J++)
			{
				yl = mYorig+(double)J*(double)CELLBLK*mDy;
				yu = mYorig+(double)(J+1)*(double)CELLBLK*mDy;

				// 
				if (xl <= x && x < xu && yl <= y && y < yu)
				{
					// ǂ̃Zɂ邩T

					double wXorig = mXorig + (double)I*(double)CELLBLK*mDx;
					double wYorig = mYorig + (double)J*(double)CELLBLK*mDy;

					for (long i = 0; i < CELLBLK; i++)
					{
						if (CELLBLK*I + i >= xCellNum)
						{
							Eprint(__FILE__, __LINE__);
							// KsEdgeFc2d::Initial_output
							fprintf(stderr, "Can not find the cell which includes the slope unit %ld,\n", edgeArray[m].Num());
							fprintf(stderr, "which is located at [%f, %f].\n", x, y);
							Oprint();
							exit(1);
						}

						xl = wXorig+(double)i*mDx;
						xu = wXorig+(double)(i+1)*mDx;

						for (long j = 0; j < CELLBLK; j++)
						{
// 							if (CELLBLK*J + j >= yCellNum)
// 							{
// 								Eprint(__FILE__, __LINE__);
// 									// KsEdgeFc2d::Initial_output
// 									// Can not find the cell which includes
// 									// the slope unit.
// 								fprintf(stderr, "The slope unit is located at [%f, %f].\n", x, y);
// 								Oprint();
// 								exit(1);
// 							}

							// ̈̒[܂ŗ̂Ŏ x ɐi
							if (CELLBLK*J + j >= yCellNum)
							{
								goto NEXTX;
							}

							yl = wYorig+(double)j*mDy;
							yu = wYorig+(double)(j+1)*mDy;

							// 
							if (xl <= x && x < xu && yl <= y && y < yu)
							{
								edgeArray[m].Gx(CELLBLK*I + i);
								edgeArray[m].Gy(CELLBLK*J + j);

// 								// for debugging
// 								printf("edge %ld [%ld, %ld]\n", 
// 									   edgeArray[m].Num(),
// 									   edgeArray[m].Gx(), edgeArray[m].Gy());

								goto NEXTEDGE;
							}
						}
				  		NEXTX:;
					}
				}
			}
		}

		// GbWZubN邱ƂłȂ
		Eprint(__FILE__, __LINE__);
		// KsEdgeFc2d::Initial_output
		fprintf(stderr, "    Cannot find the cell block in which\n");
		fprintf(stderr, "    the edge %ld (%f, %f) is included.\n", 
				edgeArray[m].Num(), edgeArray[m].X(), edgeArray[m].Y());
		Oprint();
		exit(1);

		// GbWZ𔭌邱Ƃł̂ŁÃGbW̏
		// ɐi
	  	NEXTEDGE:;
	}

	// vZJnɂo

	mQoutc = 0.0;
	double sarea = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		if (edgeArray[i].LowestEdge() == (Boolean)YES)
		{
			mQoutc += edgeArray[i].DischargeLowerEnd();
		}

		if (edgeArray[i].Atr() == 1)
		{
		    sarea += edgeArray[i].Sarea();
		}
	}

	sp.Send_data(current_time, mQoutc);
	spSarea.Send_data(current_time, sarea/mSumArea);
	spStorage.Send_data(current_time, mStorage);

	return (Boolean)YES;
}

Boolean KsEdgeFc2d::Calculate(void)
{
	// ~x

	void* fdp; void* ldp;
	if (rp.Get_data_pack(fdp, current_time + time_step, ldp) == NO)
		return NO;

	time_t ft, lt;
	KhDMatrix fRain, lRain;
	ft = ((Data<KhDMatrix>*)fdp)->Data_time();
	lt = ((Data<KhDMatrix>*)ldp)->Data_time();
	fRain = ((Data<KhDMatrix>*)fdp)->Value();
	lRain = ((Data<KhDMatrix>*)ldp)->Value();

	time_t tt = current_time + time_step;

	if (tt == ft)
	{
		mRainn = fRain;
	}
	else if (tt == lt)
	{
		mRainn = lRain;
	}
	else
	{
		fRain *= (double)(lt-tt)/(double)(lt-ft);
		lRain *= (double)(tt-ft)/(double)(lt-ft);

		mRainn = fRain + lRain;
	}

	// next step ̏Ԃ̌vZ

	double all_rain=0.0;  // temporary defined n Nov. 5, 2002
	double all_area=0.0;  // temporary defined n Nov. 5, 2002

	mQoutn = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		// edgeArray[i] ɑΉn_̉Jʒl擾
		double wRainn = mRainn(edgeArray[i].Gx(), edgeArray[i].Gy());

		all_rain = all_rain + wRainn*edgeArray[i].Area();
		all_area = all_area + edgeArray[i].Area();

// 		// for debugging
// 		printf("edge %ld (%f)\n", edgeArray[i].Num(), wRainn);

// 		// for debugging
// 		printf("edge %ld [%ld, %ld]\n", edgeArray[i].Num(), 
// 			edgeArray[i].Gx(), edgeArray[i].Gy());

		// ovZ
		if (edgeArray[i].Calculate(wRainn) == (Boolean)NO)
		{
			Eprint(__FILE__, __LINE__);
				// 
			Oprint();
			exit(1);
		}

		//  edgeArray[i] ŉGbWȂΗoʂ
		// 킹
		if (edgeArray[i].LowestEdge() == (Boolean)YES)
		{
			mQoutn += edgeArray[i].DischargeLowerEnd();
		}
	}

	// Oa̖ʐςƒʂvZ
	double sarea = 0.0;
	double storage = 0.0;
	for (long i = 0; i < numberOfEdges; i++)
	{
		if (edgeArray[i].Atr() == 1) // _-_GbW
		{
			sarea += edgeArray[i].Sarea();
			storage += edgeArray[i].Storage();
		}
	}

	// ܂ł̑o
	mSumQout += (mQoutc + mQoutn) * (double)time_step * 0.5;

// 	// _ł̒
// 	mStorage = mSumRain - mSumQout;

	// o 
	sp.Send_data(current_time + time_step, mQoutn);
	spSarea.Send_data(current_time + time_step, sarea/mSumArea);
//	spStorage.Send_data(current_time + time_step, mStorage);
//	spStorage.Send_data(current_time + time_step, storage);
	spStorage.Send_data(current_time + time_step, storage/mSumArea);
	
	mQoutc = mQoutn;

//	printf("%ld %f\n", current_time+time_step, mQoutn);
//	printf("%ld %f (%f)\n", current_time+time_step, mQout, mRainn);
//	printf("%f %f\n", mSumQout, mSumRain);
//	printf("%f %f\n", mQoutn, storage);

/*  	printf("[%s %d] %ld : %f   ", object_name, object_number,
  		current_time + time_step, mQoutn);

  	printf("all_rain = %f\n", all_rain/all_area);  //̖ʐωJʂ̏o
*/       
//	all_rain_file <<current_time + time_step<<" "   // sayama 3sg
//                      <<mQoutn<<" "               //            *
//                      <<all_rain/all_area<<endl;
//					  <<all_rain << " " << all_area << " " << object_number << endl;   // *
 	return (Boolean)YES;
}





