/*;  portlist.h {\documentstyle[fleqn]{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.1 $$ {\rhead{\sl portlist.h\quad\thepage}} */
/*;  $$Date: 2000/12/02 09:36:29 $$  */
/*;  $$Source: /home/shiiba/ohymos-lib/ohymos-current/portlist.h,v $$  */
/*;  $$RCShost: yodo.kuciv.kyoto-u.ac.jp $$  */

// @(#)

/*
{\ {\setlength{\parskip}{4pt}% latex-mode
...
}% end of latex-mode }
*/

// modified by iYutaka (Sun Feb 18 13:12:26 2001)
// These two files have to be included before p_tmp.h.
#include "khmatrix.h"      // $B9TNs%/%i%9(B KhMatrix
#include "i_file_matrix.h"

#include "p_tmp.h"
// #include "p_tmp.cc"

static Relay<double> a1;
static Receive<double> a2;
static Send<double> a3;

static I_file<double> a4;
static O_file<double> a5;

////////////////////////////////////////////////////////////////////////
// added by iYutaka (Wed Dec 27 19:15:06 2000)

typedef KhMatrix<double> KhDMatrix;
static I_file_matrix<KhDMatrix> a6;
static ReceiveNointp<KhDMatrix> a7;

static Port* gPortSet[] = { &a1
                            ,&a2
                            ,&a3
                            ,&a4
                            ,&a5
                            ,&a6
                            ,&a7
};

/*; Local Variables: *** */
/*; tab-width: 4 *** */
/*; fill-column: 72 *** */
/*; End: *** */

/*; end of file */
