/* i_file_matrix.cc */

// Input_file::Input_data(void) $B$r;29M$K:n@.$7$?(B
// Yutaka ICHIKAWA (Sat May  1 19:15:49 1999)

// $B%l!<%@!<1+NL%G!<%?$r(B, $B$=$N$^$^$NJB$S$N$^$^$KFI$_9~$a$k$h$&$K(B 
// $B%G!<%?$rFI$_9~$`=gHV$rJQ99$7$?!#9_1+6/EY%G!<%?$H%b%G%k:BI87O(B
// $B$H$NBP1~$O0J2<$NDL$j!#%b%G%k:BI87O$NBh(B N $B9T$N%G!<%?$,(B, $B9_1+(B
// $B6/EY%G!<%?$N%U%!%$%k$NBh(B 1 $B9T$KBP1~$9$k!#$D$^$j(B, $B9_1+6/EY%G!<%?(B
// $B$O:8>e6y$+$i=g$KJB$Y$l$P$h$$!#(B
// Yasuto TACHIKAWA (Jan 2, 2002)
//                           -------------------------
//  $B!0(B  $BBh(B N $B9T(B              | $B%b%G%k:BI87O$NBh(B N $B9T(B | $B%U%!%$%k$NBh(B1$B9T(B
//  $B!C(B  $BBh(BN-1$B9T(B              |               $BBh(BN-1$B9T(B |   
//  $B!C(B                       |                       |
//  $B!C(B                       |                       |
//  $B!C(B                       |                       |
//  $B!C(B  $BBh(B 2 $B9T(B              |               $BBh(B 2 $B9T(B |
//  $B!C(B  $BBh(B 1 $B9T(B              |               $BBh(B 1 $B9T(B | $B%U%!%$%k$NBh(BN$B9T(B
//   ----------------->      -------------------------
//      $B%b%G%k:BI87O(B           $B9_1+6/EY%G!<%?(B
//
// $B$b$H$b$H$N%b%G%k$N:BI87O$H9_1+6/EY%G!<%?$NBP1~$O0J2<$N$h$&$G$"$C$?!#(B
// $B%b%G%k:BI87O$NBh(B N $B9T$N%G!<%?$,(B, $B9_1+6/EY%G!<%?$N%U%!%$%k$NBh(B N $B9T$K(B
// $BBP1~$7$F$$$?!#$D$^$j(B, $B9_1+6/EY%G!<%?$O>e2<$,5UE>$7$?7A$G%U%!%$%k$K(B
// $B5-O?$;$M$P$J$i$J$+$C$?!#(B
//                           -------------------------
//  $B!0(B  $BBh(B N $B9T(B              | $B%b%G%k:BI87O$NBh(B 1 $B9T(B | $B%U%!%$%k$NBh(B1$B9T(B
//  $B!C(B  $BBh(BN-1$B9T(B              |               $BBh(B 2 $B9T(B |   
//  $B!C(B                       |                       |
//  $B!C(B                       |                       |
//  $B!C(B                       |                       |
//  $B!C(B  $BBh(B 2 $B9T(B              |               $BBh(BN-1$B9T(B |
//  $B!C(B  $BBh(B 1 $B9T(B              |               $BBh(B N $B9T(B | $B%U%!%$%k$NBh(BN$B9T(B
//   ----------------->      -------------------------
//      $B%b%G%k:BI87O(B           $B9_1+6/EY%G!<%?(B
//

#if !defined(i_file_matrix_cc)
#define i_file_matrix_cc

#include <stdio.h>

#if defined(__MSDOS__)		// OS $B$,(B MS-DOS $B$N>l9g(B
#include <sys\stat.h>		// stat $B$NDj5A(B
#elif !defined(__MSDOS__)	// OS $B$,(B MS-DOS $B$G$J$$>l9g(B
#include <sys/stat.h>		// stat $B$NDj5A(B
#endif

// $BC<;R%/%i%9%F%s%W%l!<%H(B I_file, O_file
// #include "/home/nagatani/ohymos-lib/ohymos-3.0d/htmls/data2str.h"
// #include "/home/nagatani/ohymos-lib/ohymos-3.0d/htmls/p_tmp.h"
         // $BC<;R%/%i%9%F%s%W%l!<%H(B I_file, O_file
// #include "/home/nagatani/ohymos-lib/ohymos-3.0d/htmls/ostring.h"
       // $BJ8;zNs%/%i%9(B OHyMosString

#include "data2str.h"
#include "p_tmp.h"
         // $BC<;R%/%i%9%F%s%W%l!<%H(B I_file, O_file
#include "ostring.h"
       // $BJ8;zNs%/%i%9(B OHyMosString

#include "khmatrix.h"      // $B9TNs%/%i%9(B KhMatrix
#include "i_file_matrix.h"

// template class T $B$K$O!"(BKh?Matrix $B$,F~$k(B

template <class T>
void I_file_matrix<T>::Input_data(void)
{
  
  Set_data_pack_array();
  
  // This member function is implemented in the base class
  // Send_port. This funcition add the datapacks which may remain in
  // the list to the array.
  
  Reduce_data_pack_stock();	
  
  // This member function is implemented in the base class
  // Send_port. This funcition delete the unnecessary datapacks.
  
  // The above two member functions work well even if they are
  // executed when no data have been read in.
  
  struct stat buf;
  if (stat(object_name, &buf) != 0)
    { Eprint(__FILE__, __LINE__); Oprint(); return; }
  // Input_file::Input_data(void)
  // Cannot get status of 'input_file'. 
  
  if (buf.st_mtime <= file_time_at_input) return;
  // the input file was not updated.
  
  FILE* fp = fopen(object_name, "r");	
  if (fp == NULL) {
    Eprint_fopen(__FILE__, __LINE__, object_name, "r");
    // Input_file::Input_data(void)
    Oprint(); exit(3);
  }
  
  // calculate maximum line length
  char buffer;
  int c, c_max;
  for (c = 0, c_max = -1; (buffer = fgetc(fp)) != EOF;) {
    c++;
    if (buffer == '\n') { c_max = (c_max > c) ? c_max : c; c = 0; }
  }
  c_max = (c_max > c) ? c_max : c;
  if (c_max <= 0)
    { fclose(fp); Eprint(__FILE__, __LINE__); Oprint(); return; }
  // Input_file::Input_data(void)
  // Cannot send input data from this 'input_file'. 
  
  char* line_data = new char[c_max + 1];
  if (line_data == NULL) {
    fclose(fp);
    Eprint_memory(__FILE__, __LINE__, "char", (c_max + 1));
    // Input_file::Input_data(void)
    // For buffer string to read 'input_file'. 
    Oprint(); exit(5);
  }
  
  //  printf("*** c_max = %d \n", c_max);

  fseek(fp, 0, 0);	// return to top
  
  //	time_t wt; int wRow, wCol;	// $B;~9o!"9T?t!"Ns?t(B
  time_t wt; int wGx, wGy;	// $B;~9o!"(Bx$BJ}8~$N%;%k?t!"(By$BJ}8~$N%;%k?t(B
  
  while (fgets(line_data, c_max+1, fp) != NULL) {
    if (line_data[0] == '#') continue;    // skip comment lines
    c = 0;    
    while (line_data[c] == ' ' || line_data[c] == '\t') c++;
    if (line_data[c] == '\n') continue;

    // 		// $B;~9o!"9T?t!"Ns?t$rFI$_<h$k(B
    // 		assert(sscanf(line_data, "%ld %d %d", &wt, &wRow, &wCol) == 3);
    // $B;~9o!"(Bx$BJ}8~$N%;%k?t!"(By$BJ}8~$N%;%k?t(B
    assert(sscanf(line_data, "%ld %d %d", &wt, &wGx, &wGy) == 3);
    
    // 		// for debugging
    // 		fprintf(stderr, "%ld\n", wt);
    
    // $BJ#?t9T$N%G!<%?$r5-21$9$kJ8;zNs$N%a%b%j<hF@(B
    //		char* multiLineBuffer = new char[c_max*wRow + 1];
    char* multiLineBuffer = new char[c_max*(wGy + 1)];
    
    // $BJ#?t9T$N%G!<%?$r5-21$9$kJ8;zNs$N%a%b%j$N=i4|2=(B
    for (int i=0; i < c_max*(wGy + 1); i++) {
      multiLineBuffer[i] = ' ';
    }
    long cmlb = 0;

    // $B;~9o!"9T?t!"Ns?t$N9T$r(B multiLineBuffer $B$K5-21$9$k(B
    while (line_data[c] != '\n') {
      multiLineBuffer[cmlb] = line_data[c];
      cmlb++; c++;
    }
    multiLineBuffer[cmlb] = ' ';
    cmlb++;

    // $B<B:]$N%G!<%?It$r(B multiLineBuffer $B$K5-21$9$k(B
    //		for (int i = 0; i < wRow; i++)
    for (int i = 0; i < wGy; i++) {
      do {
	assert(fgets(line_data, c_max+1, fp) != NULL);
      }
      while (line_data[0] == '#') ;    // skip comment lines
      
      c = 0;
      while (line_data[c] != '\n') {
	//
	//multiLineBuffer[cmlb] = line_data[c];
	//cmlb++; c++;
	// 
	// $B:8>e6y$+$i=g$KJB$s$@9_1+%G!<%?$rFI$_9~$`$?$a$K(B
	// $B%G!<%?$r5-O?$9$k=gHV$rJQ99$9$k!#(Btatikawa, Jan 01, 2002
	//
	multiLineBuffer[cmlb + c + (wGy-i-1)*c_max] = line_data[c];
	c++;
      }
      multiLineBuffer[cmlb + c + (wGy-i-1)*c_max] = ' ';
    }

    //        Stock(Make_data_pack(line_data));
    
    multiLineBuffer[cmlb + wGy*c_max] = '\0';

    //  printf("%s\n", multiLineBuffer);

    Stock(Make_data_pack(multiLineBuffer));
    
    delete [] multiLineBuffer;
  }
  fclose(fp);

  delete [] line_data;
  Set_data_pack_array();
  
  // print newest data time
  if (Number_of_data_packs() > 0) {
    fprintf(stderr, "File: %s  newest data time : %ld\n",
	    object_name, Newest_data_time());
  }
  
  return;
}

#endif
























