/*;  insttmp.cc {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision$$ {\rhead{\sl p\_itmp.cc\quad\thepage}} */
/*;  $$Date$$  */
/*;  $$Source$$  */
/*;  $$RCShost$$  */

// @(#) instantication of ports

#include "khboolean.h"
#include "khgrid.h"
#include "khgrid.cc"
#include "khmatrix.h"
#include "khmatrix.cc"

#include "p_tmp.cc" // template
#include "ostring.h"

#include "i_file_matrix.cc"
#include "khmatrixfunc.cc"

// -------------------------------------------------------------
// instantiation
// -------------------------------------------------------------

template class KhGrid<int>;
template class KhGrid<long>;
template class KhGrid<float>;
template class KhGrid<double>;

template class KhMatrix<int>;
template class KhMatrix<long>;
template class KhMatrix<float>;
template class KhMatrix<double>;

typedef KhMatrix<int> KhIMatrix;
typedef KhMatrix<long> KhLMatrix;
typedef KhMatrix<float> KhFMatrix;
typedef KhMatrix<double> KhDMatrix;

template class Port_type<KhIMatrix>;
template class Port_type<KhLMatrix>;
template class Port_type<KhFMatrix>;
template class Port_type<KhDMatrix>;

char* Port_type<KhIMatrix>::data_pack_type = "KhIMatrix";
char* Port_type<KhLMatrix>::data_pack_type = "KhLMatrix";
char* Port_type<KhFMatrix>::data_pack_type = "KhFMatrix";
char* Port_type<KhDMatrix>::data_pack_type = "KhDMatrix";

template class Data<KhIMatrix>;
template class Data<KhLMatrix>;
template class Data<KhFMatrix>;
template class Data<KhDMatrix>;

template class ReceiveNointp<KhIMatrix>;
template class ReceiveNointp<KhLMatrix>;
template class ReceiveNointp<KhFMatrix>;
template class ReceiveNointp<KhDMatrix>;

template class Send<KhIMatrix>;
template class Send<KhLMatrix>;
template class Send<KhFMatrix>;
template class Send<KhDMatrix>;

template class Relay<KhIMatrix>;
template class Relay<KhLMatrix>;
template class Relay<KhFMatrix>;
template class Relay<KhDMatrix>;

template class I_file_matrix<KhIMatrix>;
template class I_file_matrix<KhLMatrix>;
template class I_file_matrix<KhFMatrix>;
template class I_file_matrix<KhDMatrix>;

template class I_file<KhIMatrix>;
template class I_file<KhLMatrix>;
template class I_file<KhFMatrix>;
template class I_file<KhDMatrix>;

template class O_file<KhIMatrix>;
template class O_file<KhLMatrix>;
template class O_file<KhFMatrix>;
template class O_file<KhDMatrix>;

template void dstr2data(char*& dstr, KhIMatrix& a);
template void dstr2data(char*& dstr, KhLMatrix& a);
template void dstr2data(char*& dstr, KhFMatrix& a);
template void dstr2data(char*& dstr, KhDMatrix& a);

template void data2file(KhIMatrix& a, FILE* fp);
template void data2file(KhLMatrix& a, FILE* fp);
template void data2file(KhFMatrix& a, FILE* fp);
template void data2file(KhDMatrix& a, FILE* fp);

template void data2ofile(KhIMatrix& a, FILE* fp);
template void data2ofile(KhLMatrix& a, FILE* fp);
template void data2ofile(KhFMatrix& a, FILE* fp);
template void data2ofile(KhDMatrix& a, FILE* fp);

/*; end of file */
